<?php
namespace SalvatoreEckel\T3wrapper\Controller;

/***************************************************************
 *
 *  Copyright notice
 *
 *  (c) 2016 Salvatore Eckel <salvaracer@gmx.de>, ie
 *  
 *  All rights reserved
 *
 *  This script is part of the TYPO3 project. The TYPO3 project is
 *  free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  The GNU General Public License can be found at
 *  http://www.gnu.org/copyleft/gpl.html.
 *
 *  This script is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  This copyright notice MUST APPEAR in all copies of the script!
 ***************************************************************/

/**
 * AbstractController
 */
class AbstractController extends \TYPO3\CMS\Extbase\Mvc\Controller\ActionController {

	/**
	 * persistence manager
	 *
	 * @var \TYPO3\CMS\Extbase\Persistence\PersistenceManagerInterface
	 * @inject
	 */
	protected $persistenceManager;

	/**
	 * wrapperRepository
	 *
	 * @var \SalvatoreEckel\T3wrapper\Domain\Repository\WrapperRepository
	 * @inject
	 */
	protected $wrapperRepository = NULL;

	/**
	 * @var \TYPO3\CMS\Extbase\Domain\Repository\FrontendUserRepository
	 * @inject
	 */
	protected $userRepository;

	/**
	 * test
	 */
    protected function testAbstract() {
    }

	/**
	 * get page tree view
	 *
	 * @return PageTreeView
	 */
	public function getPageTreeView() {
		$where = 'deleted=0 ';
		$where .= "AND pid = 0 ";
		$limit = '1';
		$result = $GLOBALS['TYPO3_DB']->exec_SELECTgetRows('uid','pages',$where,'','',$limit);
		$rootPageUid = $result[0]['uid'];

		// Get page record for tree starting point
		$startingPoint = $rootPageUid;
		$pageRecord = \TYPO3\CMS\Backend\Utility\BackendUtility::getRecord(
				'pages',
				$startingPoint
		);

		// Create and initialize the tree object
		/** @var $tree \TYPO3\CMS\Backend\Tree\View\PageTreeView */
		$tree = \TYPO3\CMS\Core\Utility\GeneralUtility::makeInstance('TYPO3\\CMS\\Backend\\Tree\\View\\PageTreeView');
		$tree->init('AND ' . $GLOBALS['BE_USER']->getPagePermsClause(1));

		// Creating the icon for the current page and add it to the tree
		$tree->tree[] = array(
		 'row' => $pageRecord,
		 'HTML' => $html
		);

		// Create the page tree, from the starting point, 2 levels deep
		$depth = 25;
		$tree->getTree(
		     $startingPoint,
		     $depth,
		     ''
		);

		return $tree;
	}
}
